<?php

namespace FiloBlu\Refilo\Remote\Entity;

/**
 * Class Category
 * @package FiloBlu\Refilo\Remote\Entity
 */
class Category extends AbstractEntity
{
    const NAME = 'name';
    const LEVEL = 'level';
    const DESCRIPTION = 'description';
    const POSITION = 'position';
    const PARENT_ID = 'parent_id';
    const CREATED_AT = 'created_at';
    const UPDATED_AT = 'updated_at';
    const META_KEYWORDS = 'meta_keywords';
    const META_TITLE = 'meta_title';
    const META_DESCRIPTION = 'meta_description';
    const CHILDERN_COUNT = 'children_count';
    const PERMISSIONS = 'permissions';
    const META_ROBOTS  = 'meta_robots';
    const CATEGORY_SEO_NAME = 'category_seo_name';

    /**
     * Product constructor.
     * @param array $data
     */
    public function __construct(array $data = [])
    {
        parent::__construct($data);
        $this->setData('docType', 'category');
    }

    /**
     * @param $position
     * @return $this
     */
    public function setPosition($position)
    {
        $this->setData(self::POSITION, $position);
        return $this;
    }

    /**
     * @param $parentId
     * @return $this
     */
    public function setParentId($parentId)
    {
        $this->setData(self::PARENT_ID, $parentId);
        return $this;
    }
    /**
     * @param $date
     * @return $this
     */
    public function setCreatedAt($date)
    {
        $this->setData(self::CREATED_AT, $date);
        return $this;
    }

    /**
     * @param $date
     * @return $this
     */
    public function setUpdatedAt($date)
    {
        $this->setData(self::UPDATED_AT, $date);
        return $this;
    }

    /**
     * @param $name
     * @return $this
     */
    public function setName($name)
    {
        $this->setData(self::NAME, $name);
        return $this;
    }
    /**
     * @param $level
     * @return $this
     */
    public function setLevel($level)
    {
        $this->setData(self::LEVEL, $level);
        return $this;
    }

    /**
     * @param $description
     * @return $this
     */
    public function setDescription($description)
    {
        $this->setData(self::DESCRIPTION, $description);
        return $this;
    }

    /**
     * @param $metaTitle
     * @return $this
     */
    public function setMetaTitle($metaTitle)
    {
        $this->setData(self::META_TITLE, $metaTitle);
        return $this;
    }

    /**
     * @param $metaKeywords
     * @return $this
     */
    public function setMetaKeywords($metaKeywords)
    {
        $this->setData(self::META_KEYWORDS, $metaKeywords);
        return $this;
    }

    /**
     * @param $metaDescription
     * @return $this
     */
    public function setMetaDescription($metaDescription)
    {
        $this->setData(self::META_DESCRIPTION, $metaDescription);
        return $this;
    }

    /**
     * @param $childrenCount
     * @return $this
     */
    public function setChildrenCount($childrenCount)
    {
        $this->setData(self::CHILDERN_COUNT, $childrenCount);
        return $this;
    }

    /**
     * @param $metaRobots
     * @return $this
     */
    public function setMetaRobots($metaRobots)
    {
        $this->setData(self::META_ROBOTS, $metaRobots);
        return $this;
    }

    /**
     * @param $permissions
     * @return $this
     */
    public function setPermissions($permissions){

        $this->setData(self::PERMISSIONS, $permissions);
        return $this;
    }

    /**
     * @param $categorySeoName
     * @return $this
     */
    public function setCategorySeoName($categorySeoName){

        $this->setData(self::CATEGORY_SEO_NAME, $categorySeoName);
        return $this;
    }
}
